## edk2 0~20190606.20d2e5a1

=== debian/changelog ===
edk2 (0~20190606.20d2e5a1-2ubuntu1) eoan; urgency=medium

  * d/p/ovmf-vars-generator-ignore-qemu-warnings.patch: Avoid build
    hang resulting from unexpected QEMU warnings in output while
    enrolling keys.

 -- dann frazier <dannf@ubuntu.com>  Thu, 01 Aug 2019 22:53:39 +0000

edk2 (0~20190606.20d2e5a1-2) unstable; urgency=medium

  * debian/tests/control: Add missing dependencies on ovmf,
    qemu-efi-aarch64, and qemu-efi-arm.
  * debian/rules: Fix a comment typo in the get-orig-source rules.
  * debian/rules: Introduce a setup-build-stamp to avoid unnecessary
    BuildTools rebuilds.
  * ovmf: Add SecureBoot enabled variant:
    - debian/control: add xorriso, qemu-utils, qemu-system-x86, python3 to
      Build-Depends for the automatic key enrollment process.
    - debian/rules:
      - build a SecureBoot/SMM enabled variant of OVMF_CODE too.
      - build OVMF_VARS.ms.fd with embedded Microsoft keys from the binary
        EnrollDefaultKeys.efi
    - debian/ovmf.links: add OVMF_CODE.ms.fd.
    - debian/ovmf.install: install OVMF_VARS.ms.fd.
    - d/p/ovmf-vars-generator-Pass-OEM-Strings-to-the-guest.patch: Support
      passing in the PK/KEK via QEMU's --oemstring.
  * Reenable HTTP Boot, which was accidentally disabled due to an upstream
    macro rename.
  * Add firmware descriptor files. Closes: #932269, LP: #1836859.

 -- dann frazier <dannf@debian.org>  Wed, 31 Jul 2019 13:44:42 -0600

edk2 (0~20190606.20d2e5a1-1) experimental; urgency=medium

  * New upstream release, based on edk2-stable201905 tag.
    - d/binary-check.blacklist: Drop binaries removed upstream.
    - Remove unused embedded copy of BrotliCompress to avoid
      security scanner false-positives.
    - Adapt to upstream's use of git submodules for openssl and
      berkeley-softfloat-3.
  * debian/control: Fold and sort Build-Depends line.
  * debian/control: Add bc to Build-Depends, as it is now used by
    edksetup.sh.
  * debian/control: Add python3-distutils to Build-Depends. Part of
    the build will now use python3 instead of python if found at build-time.
    However, the build requires distutils, and upstream only embeds the
    python(2) version of that.
  * Revert "Adjust debian/rules to only build ovmf when building with -b"
    commit, as Debian now has the necessary cross-compilers.
  * Remove unnecessary sourcing of edksetup.sh. It only needs to be
    sourced in targets that need to inherent its environment.
  * Add a set of autopkgtests that verify each image type boots to a
    UEFI shell prompt in QEMU.
  * Include /usr/share/dpkg/architecture.mk instead of manually defining
    equivalent variables.

 -- dann frazier <dannf@debian.org>  Fri, 28 Jun 2019 16:07:10 -0600

=== debian/control ===
Source: edk2
Section: misc
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian QEMU Team <pkg-qemu-devel@lists.alioth.debian.org>
Uploaders: Steve Langasek <vorlon@debian.org>, Serge Hallyn <serge.hallyn@ubuntu.com>, dann frazier <dannf@debian.org>
Build-Depends: bc,
 debhelper (>= 10),
 gcc-aarch64-linux-gnu,
 gcc-arm-linux-gnueabihf,
 gcc-multilib [i386],
 iasl,
 nasm,
 python,
 python3,
 python3-distutils,
 qemu-utils,
 qemu-system-x86,
 uuid-dev,
 xorriso,
Standards-Version: 4.1.3
Homepage: http://www.tianocore.org
Vcs-Git: https://salsa.debian.org/qemu-team/edk2.git
Vcs-Browser: https://salsa.debian.org/qemu-team/edk2
Testsuite: autopkgtest
XS-Build-Indep-Architecture: amd64

Package: ovmf
Architecture: all
Depends: ${misc:Depends}
Replaces: qemu-system-common (<<1.7.0+dfsg-3ubuntu4)
Description: UEFI firmware for 64-bit x86 virtual machines
 Open Virtual Machine Firmware is a build of EDK II for 64-bit x86 virtual
 machines. It includes full support for UEFI, including Secure Boot, allowing
 use of UEFI in place of a traditional BIOS in your VM.

Package: qemu-efi-arm
Architecture: all
Depends: ${misc:Depends}
Description: UEFI firmware for 32-bit ARM virtual machines
 qemu-efi-arm is a build of EDK II for 32-bit ARM virtual machines. It
 includes full support for UEFI, including Secure Boot.

Package: qemu-efi-aarch64
Architecture: all
Depends: ${misc:Depends}
Breaks: qemu-efi (<< 0~20161202.7bbe0b3e-2)
Description: UEFI firmware for 64-bit ARM virtual machines
 qemu-efi-aarch64 is a build of EDK II for 64-bit ARM virtual machines. It
 includes full support for UEFI, including Secure Boot.

Package: qemu-efi
Architecture: all
Depends: qemu-efi-aarch64, ${misc:Depends}
Description: transitional dummy package
 This is a transitional dummy package. It contains a compatibility symlink
 of /usr/share/qemu-efi/QEMU_EFI.fd to /usr/share/qemu-efi-aarch64/QEMU_EFI.fd.

=== debian/rules ===
#!/usr/bin/make -f

SHELL=/bin/bash

include /usr/share/dpkg/architecture.mk

# Bumping this up to >= GCC5 will require the replacing the pre-compiled
# liblto*.a binaries that we strip from our orig.tar.xz.
EDK2_TOOLCHAIN = GCC49
export $(EDK2_TOOLCHAIN)_AARCH64_PREFIX=aarch64-linux-gnu-
export $(EDK2_TOOLCHAIN)_ARM_PREFIX=arm-linux-gnueabihf-

ifeq ($(DEB_BUILD_ARCH),amd64)
	EDK2_BUILD_ARCH=X64
endif
ifeq ($(DEB_BUILD_ARCH),i386)
	EDK2_BUILD_ARCH=IA32
endif
ifeq ($(DEB_BUILD_ARCH),arm64)
	EDK2_BUILD_ARCH=AARCH64
endif

ifeq ($(DEB_HOST_ARCH),amd64)
	EDK2_HOST_ARCH=X64
endif
ifeq ($(DEB_HOST_ARCH),i386)
	EDK2_HOST_ARCH=IA32
endif

COMMON_FLAGS = -DNETWORK_HTTP_BOOT_ENABLE=TRUE -DSECURE_BOOT_ENABLE=TRUE
OVMF_FLAGS   = $(COMMON_FLAGS) -DFD_SIZE_2MB -DTPM2_ENABLE=TRUE
OVMF_SB_FLAGS = $(OVMF_FLAGS) -DSMM_REQUIRE=TRUE
AAVMF_FLAGS  = $(COMMON_FLAGS)

OVMF_VARS_GENERATOR = ./qemu-ovmf-secureboot-1-1-3/ovmf-vars-generator

# Clear variables used internally by the edk2 build system
undefine WORKSPACE
undefine ECP_SOURCE
undefine EDK_SOURCE
undefine EFI_SOURCE
undefine EDK_TOOLS_PATH
undefine CONF_PATH

ver := $(shell dpkg-parsechangelog | sed -n -e's/^Version: \(.*\)-[^-]\+/\1/p')

%:
	dh $@

override_dh_auto_build: build-qemu-efi-aarch64 build-qemu-efi-arm build-ovmf

debian/setup-build-stamp:
	make -C BaseTools ARCH=$(EDK2_BUILD_ARCH)
	touch $@

OVMF_BUILD_DIR = Build/OvmfX64/RELEASE_$(EDK2_TOOLCHAIN)
OVMF_ENROLL = $(OVMF_BUILD_DIR)/X64/EnrollDefaultKeys.efi
OVMF_SHELL =  $(OVMF_BUILD_DIR)/X64/Shell.efi
OVMF_IMAGES := OVMF_CODE.fd OVMF_CODE.secboot.fd OVMF_VARS.fd
OVMF_BINARIES = $(OVMF_ENROLL) $(OVMF_SHELL)
OVMF_BINARIES += $(prefix debian/ovmf-install/,$(OVMF_IMAGES))

build-ovmf: $(OVMF_BINARIES) debian/ovmf-install/OVMF_VARS.ms.fd

$(OVMF_BINARIES): EDK2_ARCH_DIR=X64
$(OVMF_BINARIES): EDK2_HOST_ARCH=X64
$(OVMF_BINARIES): debian/setup-build-stamp
	cd UefiCpuPkg/ResetVector/Vtf0 && python Build.py
	rm -rf debian/ovmf-install
	mkdir debian/ovmf-install
	set -e; . ./edksetup.sh; \
		build -a $(EDK2_HOST_ARCH) \
			-t $(EDK2_TOOLCHAIN) \
			-p OvmfPkg/OvmfPkgX64.dsc \
			$(OVMF_FLAGS) -b RELEASE; \
		cp $(OVMF_BUILD_DIR)/FV/OVMF_*.fd \
			debian/ovmf-install/; \
		rm -rf Build/Ovmf$(EDK2_HOST_ARCH); \
		build -a $(EDK2_HOST_ARCH) \
			-t $(EDK2_TOOLCHAIN) \
			-p OvmfPkg/OvmfPkgX64.dsc \
			$(OVMF_SB_FLAGS) -b RELEASE; \
		cp $(OVMF_BUILD_DIR)/FV/OVMF_CODE.fd \
			debian/ovmf-install/OVMF_CODE.secboot.fd

dpkg_vendor = $(shell dpkg-vendor --query vendor)
debian/oem-string: debian/PkKek-1-$(dpkg_vendor).pem
	tr -d '\n' < $< | \
		sed -e 's/.*-----BEGIN CERTIFICATE-----/4e32566d-8e9e-4f52-81d3-5bb9715f9727:/' -e 's/-----END CERTIFICATE-----//' > $@

debian/iso-root/shell.img: VFAT_ROOT=debian/vfat-root
debian/iso-root/shell.img: $(OVMF_SHELL) $(OVMF_ENROLL)
	rm -rf debian/iso-root
	mkdir debian/iso-root
	rm -rf $(VFAT_ROOT)
	mkdir -p $(VFAT_ROOT)/efi/boot
	cp $(OVMF_SHELL) $(VFAT_ROOT)/efi/boot/bootx64.efi
	cp $(OVMF_ENROLL) $(VFAT_ROOT)
	qemu-img convert --image-opts \
		driver=vvfat,floppy=on,fat-type=12,label=UEFI_SHELL,dir=$(VFAT_ROOT) $@

debian/UefiShell.iso: debian/iso-root/shell.img
	xorriso --as mkisofs -input-charset ASCII -J -rational-rock \
		-e `basename $<` -no-emul-boot -o $@ `dirname $<`

debian/ovmf-install/OVMF_VARS.ms.fd: debian/UefiShell.iso debian/oem-string
	python3 $(OVMF_VARS_GENERATOR) --qemu-binary /usr/bin/qemu-system-x86_64 \
		--print-output \
		--disable-smm \
		--skip-testing \
		--oem-string `< debian/oem-string` \
		--ovmf-binary debian/ovmf-install/OVMF_CODE.fd \
		--ovmf-template-vars debian/ovmf-install/OVMF_VARS.fd \
		--uefi-shell-iso debian/UefiShell.iso \
		debian/ovmf-install/OVMF_VARS.ms.fd

build-qemu-efi: debian/setup-build-stamp
	set -e; . ./edksetup.sh; \
		build -a $(EDK2_HOST_ARCH) \
			-t $(EDK2_TOOLCHAIN) \
			-p ArmVirtPkg/ArmVirtQemu.dsc \
			$(AAVMF_FLAGS) -b RELEASE
	dd if=/dev/zero of=Build/ArmVirtQemu-$(EDK2_HOST_ARCH)/RELEASE_$(EDK2_TOOLCHAIN)/FV/$(FW_NAME)_CODE.fd bs=1M seek=64 count=0
	dd if=Build/ArmVirtQemu-$(EDK2_HOST_ARCH)/RELEASE_$(EDK2_TOOLCHAIN)/FV/QEMU_EFI.fd of=Build/ArmVirtQemu-$(EDK2_HOST_ARCH)/RELEASE_$(EDK2_TOOLCHAIN)/FV/$(FW_NAME)_CODE.fd conv=notrunc
	dd if=/dev/zero of=Build/ArmVirtQemu-$(EDK2_HOST_ARCH)/RELEASE_$(EDK2_TOOLCHAIN)/FV/$(FW_NAME)_VARS.fd bs=1M seek=64 count=0

build-qemu-efi-aarch64:
	$(MAKE) -f debian/rules build-qemu-efi EDK2_ARCH_DIR=AArch64 EDK2_HOST_ARCH=AARCH64 FW_NAME=AAVMF

build-qemu-efi-arm:
	$(MAKE) -f debian/rules build-qemu-efi EDK2_ARCH_DIR=Arm EDK2_HOST_ARCH=ARM FW_NAME=AAVMF32

override_dh_auto_clean:
	set -e; \
	if [ -d BaseTools/Source/C/bin ]; then \
		. ./edksetup.sh; build clean; \
		make -C BaseTools clean; \
	fi
	rm -rf Conf/.cache Build .pc-post
	rm -rf debian/ovmf-install debian/iso-root debian/vfat-root
	rm -f debian/oem-string debian/setup-build-stamp
	rm -f debian/shell.img debian/UefiShell.iso

get-orig-source:
	# Should be executed on a checkout of the upstream master branch,
	# with the debian/ directory manually copied in.
	git clone . edk2-$(ver)
	# Don't recurse, openssl will bring in MBs of stuff we don't need
	cd edk2-$(ver) && git submodule update --init
	find edk2-$(ver) -name .git | xargs rm -rf
	ln -s ../debian edk2-$(ver)
	# Remove unused embedded source, requested by Ubuntu security team
	rm -r edk2-$(ver)/BaseTools/Source/C/BrotliCompress
	# Remove known-binary files
	cd edk2-$(ver) && python3 ./debian/remove-binaries.py
	# Look for possible unknown binary files
	cd edk2-$(ver) && python3 ./debian/find-binaries.py
	rm edk2-$(ver)/debian
	tar Jcvf ../edk2_$(ver).orig.tar.xz edk2-$(ver)
	rm -rf edk2-$(ver)

.PHONY: build-ovmf build-qemu-efi

## edk2 0~20191122.bd85bf54

=== BaseTools/Source/C/GenFw/Makefile ===
## @file
# Windows makefile for 'GenFw' module build.
#
# Copyright (c) 2009 - 2010, Intel Corporation. All rights reserved.<BR>
# SPDX-License-Identifier: BSD-2-Clause-Patent
#
!INCLUDE ..\Makefiles\ms.common

APPNAME = GenFw

LIBS = $(LIB_PATH)\Common.lib

OBJECTS = GenFw.obj ElfConvert.obj Elf32Convert.obj Elf64Convert.obj

#CFLAGS = $(CFLAGS) /nodefaultlib:libc.lib

!INCLUDE ..\Makefiles\ms.app

=== debian/changelog ===
edk2 (0~20191122.bd85bf54-2ubuntu3.6) focal-security; urgency=medium

  * SECURITY UPDATE: integer underflow
    - debian/patches/CVE-2021-38578.patch: Add SafeIntLib to check for
      under or overflows
    - CVE-2021-38578

 -- Bruce Cable <bruce.cable@canonical.com>  Tue, 08 Oct 2024 18:01:22 +1100

edk2 (0~20191122.bd85bf54-2ubuntu3.5) focal; urgency=medium

  * Disable the built-in Shell when SecureBoot is enabled, CVE-2023-48733.
    Thanks to Mate Kukri. LP: #2040137.
    - Backport support for GetSetupMode() and IsSecureBootEnabled():
      + 0001-SecurityPkg-Create-SecureBootVariableLib.patch
      + 0002-ArmVirtPkg-add-SecureBootVariableLib-class-resolutio.patch
      + 0003-OvmfPkg-add-SecureBootVariableLib-class-resolution.patch
      + 0004-SecurityPkg-SecureBootVariableLib-Added-newly-suppor.patch
      + 0005-EmulatorPkg-add-SecureBootVariableLib-class-resoluti.patch
    - Disable the built-in Shell when SecureBoot is enabled:
      + Disable-the-Shell-when-SecureBoot-is-enabled.patch

 -- dann frazier <dannf@ubuntu.com>  Tue, 13 Feb 2024 17:52:30 -0700

edk2 (0~20191122.bd85bf54-2ubuntu3.4) focal; urgency=medium

  [ dann frazier ]
  * Provide 4MB OVMF images: The existing 2MB images no longer
    have sufficient variable space for the current Secure Boot
    Forbidden Signature Database. (LP: #1885662)
    - Convert targets for pre-enrolled variable template images
      into pattern rules. This will be useful for adding additional
      pre-enrolled variable templates.
    - Update fw descriptors to reference 4M images instead of their
      2M counterparts. This will migrate tools that use the descriptor
      interface (like libvirt) over to the 4M images when creating new
      VMs. Existing 2M VMs will require manual migration.
  * Increase autopkgtest timeout from 30s to 60s. (LP: #1885186)

  [ Mustafa Kemal Gilor ]
  * Added autopkg tests for 4MB OVMF images. (LP: #1885662)

 -- Mustafa Kemal GILOR <mustafa.gilor@canonical.com>  Tue, 08 Nov 2022 11:40:07 +0300

edk2 (0~20191122.bd85bf54-2ubuntu3.3) focal-security; urgency=medium

  * SECURITY UPDATE: Insufficient input validation in MdeModulePkg
    - debian/patches/CVE-2019-11098-*.patch
    - CVE-2019-11098
  * SECURITY UPDATE: overflow in openssl EVP_DecryptUpdate
    - debian/patches/CVE-2021-23840.patch
    - CVE-2021-23840
  * SECURITY UPDATE: DoS via incorrect ASN.1 string termination in openssl
    - debian/patches/CVE-2021-3712-*.patch
    - CVE-2021-3712
  * SECURITY UPDATE: remote buffer overflow in IScsiHexToBin
    - debian/patches/CVE-2021-38575-*.patch
    - CVE-2021-38575

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Mon, 20 Sep 2021 09:11:31 -0400

edk2 (0~20191122.bd85bf54-2ubuntu3.2) focal-security; urgency=medium

  * SECURITY UPDATE: unlimited FV recursion
    - debian/patches/CVE-2021-28210-1.patch: assert SectionInstance
      invariant in FindChildNode() in
      MdeModulePkg/Core/Dxe/SectionExtraction/CoreSectionExtraction.c.
    - debian/patches/CVE-2021-28210-2.patch: limit FwVol encapsulation
      section recursion in MdeModulePkg/Core/Dxe/DxeMain.inf,
      MdeModulePkg/Core/Dxe/SectionExtraction/CoreSectionExtraction.c,
      MdeModulePkg/MdeModulePkg.dec, MdeModulePkg/MdeModulePkg.uni.
    - CVE-2021-28210
  * SECURITY UPDATE: possible heap corruption in LzmaUefiDecompressGetInfo
    - debian/patches/CVE-2021-28211.patch: catch 4GB+ uncompressed
      buffer sizes in
      MdeModulePkg/Library/LzmaCustomDecompressLib/LzmaDecompress.c,
      MdeModulePkg/Library/LzmaCustomDecompressLib/LzmaDecompressLibInternal.h.
    - CVE-2021-28211

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Mon, 12 Apr 2021 08:18:49 -0400

edk2 (0~20191122.bd85bf54-2ubuntu3.1) focal-security; urgency=medium

  * Fix integer overflow in DxeImageVerificationHandler. (CVE-2019-14562)
  * CryptoPkg/BaseCryptLib: fix NULL dereference. (CVE-2019-14584)

 -- dann frazier <dannf@ubuntu.com>  Tue, 15 Dec 2020 15:33:20 -0700

edk2 (0~20191122.bd85bf54-2ubuntu3) focal; urgency=medium

  * Actually install the new "ms" descriptor.

 -- dann frazier <dannf@ubuntu.com>  Sat, 11 Apr 2020 10:19:44 -0600

edk2 (0~20191122.bd85bf54-2ubuntu2) focal; urgency=medium

  * Bring back (and fix) the "ms" option and restore the behavior of the
    "secboot" option, which had changed when libvirt moved from built-in
    nvram configs to parsing external firmware descriptors. LP: #1864532.
    - Reintroduce OVMF_CODE.ms.fd symlink, but now it points to
      OVMF_CODE.secboot.fd instead of OVMF_CODE.fd, which enforces SMM.
    - Update firmware descriptor JSON files:
      + Update the existing secboot descriptor to use an empty variable
        store. This makes it Secure Boot-capable, but with Secure Boot
        initially disabled. Note that previously it used a store w/ keys
        pre-enrolled, without advertising that feature.
      + Add a new "ms" descriptor which has keys pre-enrolled, has Secure
        Boot enabled, and advertises the "enrolled-keys" feature.
      + Provide more details in "description" fields.
    - README.Debian: Improve the use-case description for each image.

 -- dann frazier <dannf@ubuntu.com>  Fri, 03 Apr 2020 07:47:19 -0600

edk2 (0~20191122.bd85bf54-2ubuntu1) focal; urgency=medium

  * Fix numeric truncation in S3BootScript[Save]*() API. (CVE-2019-14563)
  * Fix use-after-free in PcdHiiOsRuntimeSupport. (CVE-2019-14586)
  * Clear memory before free to avoid potential password leak.
    (CVE-2019-14558)
  * Fix double-unmap in SdMmcCreateTrb(). This did not impact any
    of the images built from this package. (CVE-2019-14587)
  * Fix memory leak in ArpOnFrameRcvdDpc(). (CVE-2019-14559)
  * Fix issue that could allow an efi image with a blacklisted hash in the
    dbx to be loaded. (CVE-2019-14575)
  * Fix a memory leak in the ARP handler. (CVE-2019-14559)

 -- dann frazier <dannf@ubuntu.com>  Mon, 16 Mar 2020 10:56:00 -0600

edk2 (0~20191122.bd85bf54-2) unstable; urgency=medium



=== debian/control ===
--- 
+++ 
@@ -5,13 +5,12 @@
 XSBC-Original-Maintainer: Debian QEMU Team <pkg-qemu-devel@lists.alioth.debian.org>
 Uploaders: Steve Langasek <vorlon@debian.org>, Serge Hallyn <serge.hallyn@ubuntu.com>, dann frazier <dannf@debian.org>
 Build-Depends: bc,
- debhelper (>= 10),
+ debhelper-compat (= 12),
  gcc-aarch64-linux-gnu,
  gcc-arm-linux-gnueabihf,
  gcc-multilib [i386],
  iasl,
  nasm,
- python,
  python3,
  python3-distutils,
  qemu-utils,

=== debian/rules ===
#!/usr/bin/make -f

SHELL=/bin/bash

include /usr/share/dpkg/architecture.mk

# Bumping this up to >= GCC5 will require the replacing the pre-compiled
# liblto*.a binaries that we strip from our orig.tar.xz.
EDK2_TOOLCHAIN = GCC5
export $(EDK2_TOOLCHAIN)_AARCH64_PREFIX=aarch64-linux-gnu-
export $(EDK2_TOOLCHAIN)_ARM_PREFIX=arm-linux-gnueabihf-

export PYTHON3_ENABLE=TRUE

ifeq ($(DEB_BUILD_ARCH),amd64)
	EDK2_BUILD_ARCH=X64
endif
ifeq ($(DEB_BUILD_ARCH),i386)
	EDK2_BUILD_ARCH=IA32
endif
ifeq ($(DEB_BUILD_ARCH),arm64)
	EDK2_BUILD_ARCH=AARCH64
endif

ifeq ($(DEB_HOST_ARCH),amd64)
	EDK2_HOST_ARCH=X64
endif
ifeq ($(DEB_HOST_ARCH),i386)
	EDK2_HOST_ARCH=IA32
endif

COMMON_FLAGS = -DNETWORK_HTTP_BOOT_ENABLE=TRUE -DNETWORK_TLS_ENABLE -DSECURE_BOOT_ENABLE=TRUE
OVMF_COMMON_FLAGS = $(COMMON_FLAGS) -DTPM2_ENABLE=TRUE
OVMF_2M_FLAGS = $(OVMF_COMMON_FLAGS) -DFD_SIZE_2MB
OVMF_4M_FLAGS = $(OVMF_COMMON_FLAGS) -DFD_SIZE_4MB
OVMF_2M_SMM_FLAGS = $(OVMF_2M_FLAGS) -DSMM_REQUIRE=TRUE
OVMF_4M_SMM_FLAGS = $(OVMF_4M_FLAGS) -DSMM_REQUIRE=TRUE
AAVMF_FLAGS  = $(COMMON_FLAGS)

OVMF_VARS_GENERATOR = ./qemu-ovmf-secureboot-1-1-3/ovmf-vars-generator

# Clear variables used internally by the edk2 build system
undefine WORKSPACE
undefine ECP_SOURCE
undefine EDK_SOURCE
undefine EFI_SOURCE
undefine EDK_TOOLS_PATH
undefine CONF_PATH

ver := $(shell dpkg-parsechangelog | sed -n -e's/^Version: \(.*\)-[^-]\+/\1/p')

%:
	dh $@

override_dh_auto_build: build-qemu-efi-aarch64 build-qemu-efi-arm build-ovmf

debian/setup-build-stamp:
	set -e; . ./edksetup.sh; \
	make -C BaseTools ARCH=$(EDK2_BUILD_ARCH)
	touch $@

OVMF_BUILD_DIR = Build/OvmfX64/RELEASE_$(EDK2_TOOLCHAIN)
OVMF_ENROLL = $(OVMF_BUILD_DIR)/X64/EnrollDefaultKeys.efi
OVMF_SHELL =  $(OVMF_BUILD_DIR)/X64/Shell.efi
OVMF_IMAGES := OVMF_CODE.fd OVMF_CODE_4M.fd OVMF_CODE.secboot.fd OVMF_CODE_4M.secboot.fd OVMF_VARS.fd OVMF_VARS_4M.fd
OVMF_BINARIES = $(OVMF_ENROLL) $(OVMF_SHELL)
OVMF_BINARIES += $(prefix debian/ovmf-install/,$(OVMF_IMAGES))

build-ovmf: $(OVMF_BINARIES) debian/ovmf-install/OVMF_VARS.ms.fd debian/ovmf-install/OVMF_VARS_4M.ms.fd debian/ovmf-install/OVMF_VARS.snakeoil.fd

$(OVMF_BINARIES): EDK2_ARCH_DIR=X64
$(OVMF_BINARIES): EDK2_HOST_ARCH=X64
$(OVMF_BINARIES): debian/setup-build-stamp
	cd UefiCpuPkg/ResetVector/Vtf0 && python3 Build.py
	rm -rf debian/ovmf-install
	mkdir debian/ovmf-install
	set -e; . ./edksetup.sh; \
		build -a $(EDK2_HOST_ARCH) \
			-t $(EDK2_TOOLCHAIN) \
			-p OvmfPkg/OvmfPkgX64.dsc \
			$(OVMF_2M_FLAGS) -b RELEASE; \
		cp $(OVMF_BUILD_DIR)/FV/OVMF_CODE.fd \
			$(OVMF_BUILD_DIR)/FV/OVMF.fd \
			debian/ovmf-install/; \
		cp $(OVMF_BUILD_DIR)/FV/OVMF_VARS.fd \
			debian/ovmf-install/; \
		rm -rf Build/Ovmf$(EDK2_HOST_ARCH); \
		build -a $(EDK2_HOST_ARCH) \
			-t $(EDK2_TOOLCHAIN) \
			-p OvmfPkg/OvmfPkgX64.dsc \
			$(OVMF_4M_FLAGS) -b RELEASE; \
		cp $(OVMF_BUILD_DIR)/FV/OVMF_CODE.fd \
			debian/ovmf-install/OVMF_CODE_4M.fd; \
		cp $(OVMF_BUILD_DIR)/FV/OVMF_VARS.fd \
			debian/ovmf-install/OVMF_VARS_4M.fd; \
		rm -rf Build/Ovmf$(EDK2_HOST_ARCH); \
		build -a $(EDK2_HOST_ARCH) \
			-t $(EDK2_TOOLCHAIN) \
			-p OvmfPkg/OvmfPkgX64.dsc \
			$(OVMF_2M_SMM_FLAGS) -b RELEASE; \
		cp $(OVMF_BUILD_DIR)/FV/OVMF_CODE.fd \
			debian/ovmf-install/OVMF_CODE.secboot.fd; \
		rm -rf Build/Ovmf$(EDK2_HOST_ARCH); \
		build -a $(EDK2_HOST_ARCH) \
			-t $(EDK2_TOOLCHAIN) \
			-p OvmfPkg/OvmfPkgX64.dsc \
			$(OVMF_4M_SMM_FLAGS) -b RELEASE; \
		cp $(OVMF_BUILD_DIR)/FV/OVMF_CODE.fd \
			debian/ovmf-install/OVMF_CODE_4M.secboot.fd; \

dpkg_vendor = $(shell dpkg-vendor --query vendor)
debian/oem-string-vendor: debian/PkKek-1-$(dpkg_vendor).pem
	tr -d '\n' < $< | \
		sed -e 's/.*-----BEGIN CERTIFICATE-----/4e32566d-8e9e-4f52-81d3-5bb9715f9727:/' -e 's/-----END CERTIFICATE-----//' > $@

debian/oem-string-snakeoil: debian/PkKek-1-snakeoil.pem
	tr -d '\n' < $< | \
		sed -e 's/.*-----BEGIN CERTIFICATE-----/4e32566d-8e9e-4f52-81d3-5bb9715f9727:/' -e 's/-----END CERTIFICATE-----//' > $@

debian/iso-root/shell.img: VFAT_ROOT=debian/vfat-root
debian/iso-root/shell.img: $(OVMF_SHELL) $(OVMF_ENROLL)
	rm -rf debian/iso-root
	mkdir debian/iso-root
	rm -rf $(VFAT_ROOT)
	mkdir -p $(VFAT_ROOT)/efi/boot
	cp $(OVMF_SHELL) $(VFAT_ROOT)/efi/boot/bootx64.efi
	cp $(OVMF_ENROLL) $(VFAT_ROOT)
	qemu-img convert --image-opts \
		driver=vvfat,floppy=on,fat-type=12,label=UEFI_SHELL,dir=$(VFAT_ROOT) $@

debian/UefiShell.iso: debian/iso-root/shell.img
	xorriso --as mkisofs -input-charset ASCII -J -rational-rock \
		-e `basename $<` -no-emul-boot -o $@ `dirname $<`

%.ms.fd: %.fd debian/UefiShell.iso debian/oem-string-vendor
	python3 $(OVMF_VARS_GENERATOR) --qemu-binary /usr/bin/qemu-system-x86_64 \
		--print-output \
		--disable-smm \
		--skip-testing \
		--oem-string `< debian/oem-string-vendor` \
		--ovmf-binary $(subst VARS,CODE,$<) \
		--ovmf-template-vars $< \
		--uefi-shell-iso debian/UefiShell.iso $@

%.snakeoil.fd: %.fd debian/UefiShell.iso debian/oem-string-snakeoil
	python3 $(OVMF_VARS_GENERATOR) --qemu-binary /usr/bin/qemu-system-x86_64 \
		--print-output \
		--disable-smm \
		--skip-testing \
		--no-default \
		--oem-string `< debian/oem-string-snakeoil` \
		--ovmf-binary $(subst VARS,CODE,$<) \
		--ovmf-template-vars $< \
		--uefi-shell-iso debian/UefiShell.iso $@

ArmPkg/Library/GccLto/liblto-aarch64.a:	ArmPkg/Library/GccLto/liblto-aarch64.s
	$($(EDK2_TOOLCHAIN)_AARCH64_PREFIX)gcc -c -fpic $< -o $@

ArmPkg/Library/GccLto/liblto-arm.a: ArmPkg/Library/GccLto/liblto-arm.s
	$($(EDK2_TOOLCHAIN)_ARM_PREFIX)gcc -c -fpic $< -o $@

build-qemu-efi: debian/setup-build-stamp
	set -e; . ./edksetup.sh; \
		build -a $(EDK2_HOST_ARCH) \
			-t $(EDK2_TOOLCHAIN) \
			-p ArmVirtPkg/ArmVirtQemu.dsc \
			$(AAVMF_FLAGS) -b RELEASE
	dd if=/dev/zero of=Build/ArmVirtQemu-$(EDK2_HOST_ARCH)/RELEASE_$(EDK2_TOOLCHAIN)/FV/$(FW_NAME)_CODE.fd bs=1M seek=64 count=0
	dd if=Build/ArmVirtQemu-$(EDK2_HOST_ARCH)/RELEASE_$(EDK2_TOOLCHAIN)/FV/QEMU_EFI.fd of=Build/ArmVirtQemu-$(EDK2_HOST_ARCH)/RELEASE_$(EDK2_TOOLCHAIN)/FV/$(FW_NAME)_CODE.fd conv=notrunc
	dd if=/dev/zero of=Build/ArmVirtQemu-$(EDK2_HOST_ARCH)/RELEASE_$(EDK2_TOOLCHAIN)/FV/$(FW_NAME)_VARS.fd bs=1M seek=64 count=0

build-qemu-efi-aarch64: ArmPkg/Library/GccLto/liblto-aarch64.a
	$(MAKE) -f debian/rules build-qemu-efi EDK2_ARCH_DIR=AArch64 EDK2_HOST_ARCH=AARCH64 FW_NAME=AAVMF

build-qemu-efi-arm: ArmPkg/Library/GccLto/liblto-arm.a
	$(MAKE) -f debian/rules build-qemu-efi EDK2_ARCH_DIR=Arm EDK2_HOST_ARCH=ARM FW_NAME=AAVMF32

override_dh_auto_clean:
	set -e; \
	if [ -d BaseTools/Source/C/bin ]; then \
		. ./edksetup.sh; build clean; \
		make -C BaseTools clean; \
	fi
	rm -rf Conf/.cache Build .pc-post
	rm -rf debian/ovmf-install debian/iso-root debian/vfat-root
	rm -f debian/oem-string debian/oem-string-snakeoil
	rm -f debian/shell.img debian/UefiShell.iso
	rm -f ArmPkg/Library/GccLto/liblto-*.a
	rm -f debian/setup-build-stamp

get-orig-source:
	# Should be executed on a checkout of the upstream master branch,
	# with the debian/ directory manually copied in.
	rm -rf edk2.tmp && git clone . edk2.tmp
	# Don't recurse, openssl will bring in MBs of stuff we don't need
	cd edk2.tmp && git submodule update --init
	rm -rf edk2-$(ver) && mkdir edk2-$(ver)
	cd edk2.tmp && git archive HEAD | tar xv -C ../edk2-$(ver)
	cd edk2.tmp && git submodule foreach \
		'git archive HEAD | tar xv -C $$toplevel/../edk2-$(ver)/$$sm_path'
	ln -s ../debian edk2-$(ver)
	# Remove unused embedded source, requested by Ubuntu security team
	rm -r edk2-$(ver)/BaseTools/Source/C/BrotliCompress
	# Remove known-binary files
	cd edk2-$(ver) && python3 ./debian/remove-binaries.py
	# Look for possible unknown binary files
	cd edk2-$(ver) && python3 ./debian/find-binaries.py
	rm edk2-$(ver)/debian
	tar Jcvf ../edk2_$(ver).orig.tar.xz edk2-$(ver)
	rm -rf edk2.tmp edk2-$(ver)

.PHONY: build-ovmf build-qemu-efi

=== debian/tests/control ===
Test-Command: python3 debian/tests/shell.py --arch AARCH64
Depends: qemu-efi-aarch64, qemu-system-arm, python3-pexpect

Test-Command: python3 debian/tests/shell.py --arch ARM
Depends: qemu-efi-arm, qemu-system-arm, python3-pexpect

Test-Command: python3 debian/tests/shell.py --arch X64
Depends: ovmf, qemu-system-x86, python3-pexpect

Test-Command: python3 debian/tests/shell.py --arch X64_4M
Depends: ovmf, qemu-system-x86, python3-pexpect

## edk2 2020.05

=== debian/changelog ===
edk2 (2020.05-5ubuntu0.2) groovy-security; urgency=medium

  * SECURITY UPDATE: unlimited FV recursion
    - debian/patches/CVE-2021-28210-1.patch: assert SectionInstance
      invariant in FindChildNode() in
      MdeModulePkg/Core/Dxe/SectionExtraction/CoreSectionExtraction.c.
    - debian/patches/CVE-2021-28210-2.patch: limit FwVol encapsulation
      section recursion in MdeModulePkg/Core/Dxe/DxeMain.inf,
      MdeModulePkg/Core/Dxe/SectionExtraction/CoreSectionExtraction.c,
      MdeModulePkg/MdeModulePkg.dec, MdeModulePkg/MdeModulePkg.uni.
    - CVE-2021-28210
  * SECURITY UPDATE: possible heap corruption in LzmaUefiDecompressGetInfo
    - debian/patches/CVE-2021-28211.patch: catch 4GB+ uncompressed
      buffer sizes in
      MdeModulePkg/Library/LzmaCustomDecompressLib/LzmaDecompress.c,
      MdeModulePkg/Library/LzmaCustomDecompressLib/LzmaDecompressLibInternal.h.
    - CVE-2021-28211

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Mon, 12 Apr 2021 08:12:17 -0400

edk2 (2020.05-5ubuntu0.1) groovy-security; urgency=medium

  * CryptoPkg/BaseCryptLib: fix NULL dereference (CVE-2019-14584)

 -- dann frazier <dannf@ubuntu.com>  Tue, 05 Jan 2021 16:31:45 -0700

edk2 (2020.05-5) unstable; urgency=medium

  * Update snakeoil keys. Previous one expired 2019-12-01. New one
    expires 2120-08-14.

 -- dann frazier <dannf@debian.org>  Mon, 07 Sep 2020 13:23:29 -0600

edk2 (2020.05-4) unstable; urgency=medium

  * Fix integer overflow in DxeImageVerificationHandler. (CVE-2019-14562)
    (Closes: #968819)
     - d/p/0001-SecurityPkg-DxeImageVerificationLib-extract-SecDataD.patch
     - d/p/0002-SecurityPkg-DxeImageVerificationLib-assign-WinCertif.patch
     - d/p/0003-SecurityPkg-DxeImageVerificationLib-catch-alignment-.patch
  * Re-enable TPM support, which was accidentally disabled due to an
    upstream build flag rename in 2020.05-1. LP: #1890646.

 -- dann frazier <dannf@debian.org>  Wed, 02 Sep 2020 10:26:10 -0600

edk2 (2020.05-3) unstable; urgency=medium

  * Provide 4MB OVMF images as the existing 2MB images no longer
    have sufficient variable space for the current Secure Boot Forbidden
    Signature Database. LP: #1885662.
  * Update fw descriptors to reference 4M images instead of their 2M
    counterparts. This will migrate tools that use the descriptor interface
    (like libvirt) over to the 4M images when creating new VMs. Existing 2M
    VMs will require manual migration.
  * Add a 4M snakeoil variable template and drop the 2M version. This will
    break existing snakeoil VMs, but that should be OK for a test/devel
    facility.
  * Increase autopkgtest timeout from 30s to 60s. LP: #1885186.

 -- dann frazier <dannf@debian.org>  Wed, 05 Aug 2020 18:33:22 -0600

edk2 (2020.05-2) unstable; urgency=medium

  * Enable https boot support, thanks to Dimitri John Ledkov. LP: #1883114.

 -- dann frazier <dannf@debian.org>  Thu, 11 Jun 2020 08:40:31 -0600

edk2 (2020.05-1) unstable; urgency=medium

  * New upstream release, based on edk2-stable202005 tag.

 -- dann frazier <dannf@debian.org>  Wed, 03 Jun 2020 15:39:40 -0600

edk2 (0.0~20200229-2) unstable; urgency=medium

  * Actually install the new "ms" descriptor.

 -- dann frazier <dannf@debian.org>  Sat, 11 Apr 2020 09:17:23 -0600

edk2 (0.0~20200229-1) unstable; urgency=medium

  * Reintroduce OVMF_CODE.ms.fd symlink, but now it points to
    OVMF_CODE.secboot.fd instead of OVMF_CODE.fd, which enforces SMM.
  * Update firmware descriptor JSON files:
     - Update the existing secboot descriptor to use an empty variable
       store. This makes it Secure Boot-capable, but with Secure Boot disabled.
       Previously it used a store w/ keys pre-enrolled, without advertising
       that feature.
     - Add a new "ms" descriptor which has keys pre-enrolled and Secure Boot
       enabled, and advertises the "enrolled-keys" feature.
     - Provide more details in "description" fields.
  * README.Debian: Improve the use-case description for each image.
  * Mark ovmf, qemu-efi-aarch64 and qemu-efi-arm as Multi-Arch: foreign.
    Thanks to the Multiarch hinter.
  * Change versioning scheme to reflect usage of edk2-stable<YYYYMM>
    tag releases over git snapshots.
  * Bump Standards-Version from 4.1.3 to 4.5.0.
  * Add a debian/watch file.

 -- dann frazier <dannf@debian.org>  Tue, 31 Mar 2020 16:46:58 -0600

edk2 (0~20200229.4c0f6e34-1) unstable; urgency=medium

  * New upstream release, based on edk2-stable202002 tag.
    - Fix numeric truncation in S3BootScript[Save]*() API. (CVE-2019-14563)
      (Closes: #952934)
    - Fix use-after-free in PcdHiiOsRuntimeSupport. (CVE-2019-14586)
    - Clear memory before free to avoid potential password leak.
      (CVE-2019-14558)
    - Fix double-unmap in SdMmcCreateTrb(). This did not impact any
      of the images built from this package. (CVE-2019-14587)
    - Fix memory leak in ArpOnFrameRcvdDpc(). (CVE-2019-14559)
    - Fix issue that could allow an efi image with a blacklisted hash in the
      dbx to be loaded. (CVE-2019-14575) (Closes: #952935)
    - Fix a memory leak in the ARP handler. (CVE-2019-14559) (Closes: #952926)
    - Refresh patches:
       + debian/patches/no-missing-braces.diff
       + debian/patches/no-stack-protector-all-archs.diff

 -- dann frazier <dannf@debian.org>  Fri, 13 Mar 2020 16:05:49 -0600

=== debian/control ===
--- 
+++ 
@@ -17,7 +17,7 @@
  qemu-system-x86,
  uuid-dev,
  xorriso,
-Standards-Version: 4.1.3
+Standards-Version: 4.5.0
 Homepage: http://www.tianocore.org
 Vcs-Git: https://salsa.debian.org/qemu-team/edk2.git
 Vcs-Browser: https://salsa.debian.org/qemu-team/edk2
@@ -28,6 +28,7 @@
 Architecture: all
 Depends: ${misc:Depends}
 Replaces: qemu-system-common (<<1.7.0+dfsg-3ubuntu4)
+Multi-Arch: foreign
 Description: UEFI firmware for 64-bit x86 virtual machines
  Open Virtual Machine Firmware is a build of EDK II for 64-bit x86 virtual
  machines. It includes full support for UEFI, including Secure Boot, allowing
@@ -36,6 +37,7 @@
 Package: qemu-efi-arm
 Architecture: all
 Depends: ${misc:Depends}
+Multi-Arch: foreign
 Description: UEFI firmware for 32-bit ARM virtual machines
  qemu-efi-arm is a build of EDK II for 32-bit ARM virtual machines. It
  includes full support for UEFI, including Secure Boot.
@@ -44,6 +46,7 @@
 Architecture: all
 Depends: ${misc:Depends}
 Breaks: qemu-efi (<< 0~20161202.7bbe0b3e-2)
+Multi-Arch: foreign
 Description: UEFI firmware for 64-bit ARM virtual machines
  qemu-efi-aarch64 is a build of EDK II for 64-bit ARM virtual machines. It
  includes full support for UEFI, including Secure Boot.

=== debian/rules ===
--- 
+++ 
@@ -2,10 +2,8 @@
 
 SHELL=/bin/bash
 
-include /usr/share/dpkg/architecture.mk
-
-# Bumping this up to >= GCC5 will require the replacing the pre-compiled
-# liblto*.a binaries that we strip from our orig.tar.xz.
+include /usr/share/dpkg/default.mk
+
 EDK2_TOOLCHAIN = GCC5
 export $(EDK2_TOOLCHAIN)_AARCH64_PREFIX=aarch64-linux-gnu-
 export $(EDK2_TOOLCHAIN)_ARM_PREFIX=arm-linux-gnueabihf-
@@ -30,7 +28,7 @@
 endif
 
 COMMON_FLAGS = -DNETWORK_HTTP_BOOT_ENABLE=TRUE -DNETWORK_TLS_ENABLE -DSECURE_BOOT_ENABLE=TRUE
-OVMF_COMMON_FLAGS = $(COMMON_FLAGS) -DTPM2_ENABLE=TRUE
+OVMF_COMMON_FLAGS = $(COMMON_FLAGS) -DTPM_ENABLE=TRUE
 OVMF_2M_FLAGS = $(OVMF_COMMON_FLAGS) -DFD_SIZE_2MB
 OVMF_4M_FLAGS = $(OVMF_COMMON_FLAGS) -DFD_SIZE_4MB
 OVMF_2M_SMM_FLAGS = $(OVMF_2M_FLAGS) -DSMM_REQUIRE=TRUE
@@ -47,8 +45,6 @@
 undefine EDK_TOOLS_PATH
 undefine CONF_PATH
 
-ver := $(shell dpkg-parsechangelog | sed -n -e's/^Version: \(.*\)-[^-]\+/\1/p')
-
 %:
 	dh $@
 
@@ -66,7 +62,9 @@
 OVMF_BINARIES = $(OVMF_ENROLL) $(OVMF_SHELL)
 OVMF_BINARIES += $(prefix debian/ovmf-install/,$(OVMF_IMAGES))
 
-build-ovmf: $(OVMF_BINARIES) debian/ovmf-install/OVMF_VARS.ms.fd debian/ovmf-install/OVMF_VARS_4M.ms.fd debian/ovmf-install/OVMF_VARS.snakeoil.fd
+QEMU_EFI_BUILD_DIR = Build/ArmVirtQemu-$(EDK2_HOST_ARCH)/RELEASE_$(EDK2_TOOLCHAIN)
+
+build-ovmf: $(OVMF_BINARIES) debian/ovmf-install/OVMF_VARS.ms.fd debian/ovmf-install/OVMF_VARS_4M.ms.fd debian/ovmf-install/OVMF_VARS_4M.snakeoil.fd
 
 $(OVMF_BINARIES): EDK2_ARCH_DIR=X64
 $(OVMF_BINARIES): EDK2_HOST_ARCH=X64
@@ -108,8 +106,7 @@
 		cp $(OVMF_BUILD_DIR)/FV/OVMF_CODE.fd \
 			debian/ovmf-install/OVMF_CODE_4M.secboot.fd; \
 
-dpkg_vendor = $(shell dpkg-vendor --query vendor)
-debian/oem-string-vendor: debian/PkKek-1-$(dpkg_vendor).pem
+debian/oem-string-vendor: debian/PkKek-1-$(DEB_VENDOR).pem
 	tr -d '\n' < $< | \
 		sed -e 's/.*-----BEGIN CERTIFICATE-----/4e32566d-8e9e-4f52-81d3-5bb9715f9727:/' -e 's/-----END CERTIFICATE-----//' > $@
 
@@ -165,9 +162,9 @@
 			-t $(EDK2_TOOLCHAIN) \
 			-p ArmVirtPkg/ArmVirtQemu.dsc \
 			$(AAVMF_FLAGS) -b RELEASE
-	dd if=/dev/zero of=Build/ArmVirtQemu-$(EDK2_HOST_ARCH)/RELEASE_$(EDK2_TOOLCHAIN)/FV/$(FW_NAME)_CODE.fd bs=1M seek=64 count=0
-	dd if=Build/ArmVirtQemu-$(EDK2_HOST_ARCH)/RELEASE_$(EDK2_TOOLCHAIN)/FV/QEMU_EFI.fd of=Build/ArmVirtQemu-$(EDK2_HOST_ARCH)/RELEASE_$(EDK2_TOOLCHAIN)/FV/$(FW_NAME)_CODE.fd conv=notrunc
-	dd if=/dev/zero of=Build/ArmVirtQemu-$(EDK2_HOST_ARCH)/RELEASE_$(EDK2_TOOLCHAIN)/FV/$(FW_NAME)_VARS.fd bs=1M seek=64 count=0
+	dd if=/dev/zero of=$(QEMU_EFI_BUILD_DIR)/FV/$(FW_NAME)_CODE.fd bs=1M seek=64 count=0
+	dd if=$(QEMU_EFI_BUILD_DIR)/FV/QEMU_EFI.fd of=$(QEMU_EFI_BUILD_DIR)/FV/$(FW_NAME)_CODE.fd conv=notrunc
+	dd if=/dev/zero of=$(QEMU_EFI_BUILD_DIR)/FV/$(FW_NAME)_VARS.fd bs=1M seek=64 count=0
 
 build-qemu-efi-aarch64: ArmPkg/Library/GccLto/liblto-aarch64.a
 	$(MAKE) -f debian/rules build-qemu-efi EDK2_ARCH_DIR=AArch64 EDK2_HOST_ARCH=AARCH64 FW_NAME=AAVMF
@@ -194,19 +191,22 @@
 	rm -rf edk2.tmp && git clone . edk2.tmp
 	# Don't recurse, openssl will bring in MBs of stuff we don't need
 	cd edk2.tmp && git submodule update --init
-	rm -rf edk2-$(ver) && mkdir edk2-$(ver)
-	cd edk2.tmp && git archive HEAD | tar xv -C ../edk2-$(ver)
+	rm -rf edk2-$(DEB_VERSION_UPSTREAM) && \
+		mkdir edk2-$(DEB_VERSION_UPSTREAM)
+	cd edk2.tmp && git archive HEAD | \
+		tar xv -C ../edk2-$(DEB_VERSION_UPSTREAM)
 	cd edk2.tmp && git submodule foreach \
-		'git archive HEAD | tar xv -C $$toplevel/../edk2-$(ver)/$$sm_path'
-	ln -s ../debian edk2-$(ver)
+		'git archive HEAD | tar xv -C $$toplevel/../edk2-$(DEB_VERSION_UPSTREAM)/$$sm_path'
+	ln -s ../debian edk2-$(DEB_VERSION_UPSTREAM)
 	# Remove unused embedded source, requested by Ubuntu security team
-	rm -r edk2-$(ver)/BaseTools/Source/C/BrotliCompress
+	rm -r edk2-$(DEB_VERSION_UPSTREAM)/BaseTools/Source/C/BrotliCompress
 	# Remove known-binary files
-	cd edk2-$(ver) && python3 ./debian/remove-binaries.py
+	cd edk2-$(DEB_VERSION_UPSTREAM) && python3 ./debian/remove-binaries.py
 	# Look for possible unknown binary files
-	cd edk2-$(ver) && python3 ./debian/find-binaries.py
-	rm edk2-$(ver)/debian
-	tar Jcvf ../edk2_$(ver).orig.tar.xz edk2-$(ver)
-	rm -rf edk2.tmp edk2-$(ver)
+	cd edk2-$(DEB_VERSION_UPSTREAM) && python3 ./debian/find-binaries.py
+	rm edk2-$(DEB_VERSION_UPSTREAM)/debian
+	tar Jcvf ../edk2_$(DEB_VERSION_UPSTREAM).orig.tar.xz \
+		edk2-$(DEB_VERSION_UPSTREAM)
+	rm -rf edk2.tmp edk2-$(DEB_VERSION_UPSTREAM)
 
 .PHONY: build-ovmf build-qemu-efi
